#include <stdio.h>

#include "colors.h"

void makeblocks(int *color, int len, signed char *blocks[], int range)
{
    int stack[16], stackpos, i, j;
    stackpos = 0;

    for (i = 0; i < len; i ++) {
        if (color[i] >= 0 && color[i] < range) {
            for (j = stackpos-1; j >= 0; j --) {
                if (stack[j] == color[i]) {
                    /* color is in stack */
                    stackpos = j + 1;
                    goto fillblocks;
                }
            }
            /* color not in stack */
            stack[stackpos] = color[i];
            stackpos ++;
            goto fillblocks;
        }
        else if (color[i] == -1) {
            /* dont care color */
            goto filldontcare;
        }
        else {
            /* undefined color - pop everything */
            stackpos = 0;
            goto fillblocks;
        }
    fillblocks:
        for (j = 0; j < range; j ++)
            blocks[j][i] = 0;
        for (j = 0; j < stackpos-1; j ++)
            blocks[stack[j]][i] = -1;
        if (stackpos > 0)
            blocks[stack[stackpos-1]][i] = 1;
        continue;
    filldontcare:
        for (j = 0; j < range; j ++)
            blocks[j][i] = -1;
    }
}
