#include <stdio.h>
#include <stdlib.h>

#include "parser.h"
#include "opt.h"
#include "placetags.h"
#include "colors.h"
#include "findrun.h"
#include "plain.h"

int o_length;

ENTITY *o_ents;
TAGHOLDER *o_tags;

signed char *o_bold, *o_emph, *o_italic, *o_strong, *o_tt;
signed char *o_u1, *o_u2, *o_u3;
signed char *o_color[8], *o_size[10];
signed char *o_plain;

signed char *o_block[BLOCKCOUNT];
signed char *o_temp[BLOCKCOUNT];

char *tagstr[] = { "B", "EM", "I", "PL", "S", "TT", "U",
    "0", "1", "2", "3", "4", "5", "6", "7", "8", "9",
    "r", "g", "b", "c", "m", "y", "k", "w" };

TAG o_taglist[] = {
    T_B, T_EM, T_I, T_S, T_TT, T_U, T_U, T_U,
    T_r, T_g, T_b, T_c, T_m, T_y, T_k, T_w,
    T_0, T_1, T_2, T_3, T_4, T_5, T_6, T_7, T_8, T_9,
    T_PL
};
 
static void makearrays()
{
    int i;
    int *colorarray, *sizearray;

    o_bold   = malloc(o_length);
    o_emph   = malloc(o_length);
    o_italic = malloc(o_length);
    o_strong = malloc(o_length);
    o_tt     = malloc(o_length);
    o_u1     = malloc(o_length);
    o_u2     = malloc(o_length);
    o_u3     = malloc(o_length);
    for (i = 0; i < 8; i ++) o_color[i] = malloc(o_length);
    for (i = 0; i < 10; i ++) o_size[i] = malloc(o_length);
    o_plain  = malloc(o_length);

    colorarray = malloc(o_length * sizeof(int));
    sizearray = malloc(o_length * sizeof(int));

    for (i = 0; i < BLOCKCOUNT; i ++)
        o_temp[i] = calloc(o_length, 1);

    for (i = 0; i < o_length; i ++) {
        o_bold[i]   = o_ents[i].bold;
        o_emph[i]   = o_ents[i].emph;
        o_italic[i] = o_ents[i].italic;
        o_strong[i] = o_ents[i].strong;
        o_tt[i]     = o_ents[i].tt;
        o_u1[i] = o_u2[i] = o_u3[i] = 0;
        switch (o_ents[i].underline) {
        case 3: o_u3[i] = 1; /* fallthrough */
        case 2: o_u2[i] = 1; /* fallthrough */
        case 1: o_u1[i] = 1; /* fallthrough */
        }
        colorarray[i] = o_ents[i].color;
        sizearray[i]  = o_ents[i].size;
        o_plain[i]    = 0;
    }

    makeblocks(colorarray, o_length, o_color, 8);
    makeblocks(sizearray, o_length, o_size, 10);
}

static char *makeoutput()
{
    char *output;
    int outputpos, outputsize, i, j;
    outputsize = 0;
    for (i = 0; i <= o_length; i ++) {
        if (i < o_length)
            outputsize += strlen(o_ents[i].text);
        outputsize += 4 * o_tags[i].openlen + 5 * o_tags[i].closelen;
    }
    output = malloc(outputsize + 1);
    outputpos = 0;
    for (i = 0; i <= o_length; i ++) {
        for (j = o_tags[i].closelen-1; j >= 0; j --) {
            strcpy(output+outputpos, "</");
            outputpos += 2;
            strcpy(output+outputpos, tagstr[o_tags[i].close[j]]);
            outputpos += strlen(tagstr[o_tags[i].close[j]]);
            strcpy(output+outputpos, ">");
            outputpos ++;
        }
        for (j = 0; j < o_tags[i].openlen; j ++) {
            strcpy(output+outputpos, "<");
            outputpos ++;
            strcpy(output+outputpos, tagstr[o_tags[i].open[j]]);
            outputpos += strlen(tagstr[o_tags[i].open[j]]);
            strcpy(output+outputpos, ">");
            outputpos ++;
        }
        if (i < o_length) {
            strcpy(output+outputpos, o_ents[i].text);
            outputpos += strlen(o_ents[i].text);
        }
    }
    return output;
}

char *opt(ENTITY *ent)
{
    int i;

    o_ents = ent;
    /* work out entity list length */
    for (o_length = 0; o_ents[o_length].text; o_length ++);

    o_tags = malloc(sizeof(TAGHOLDER) * (o_length+1));
    for (i = 0; i <= o_length; i ++)
        o_tags[i].openlen = o_tags[i].closelen = 0;

    /*fprintf(stderr, "makearray\n");*/
    makearrays();
    insertplain();

    o_block[0]  = o_bold;
    o_block[1]  = o_emph;
    o_block[2]  = o_italic;
    o_block[3]  = o_strong;
    o_block[4]  = o_tt;
    o_block[5]  = o_u1;
    o_block[6]  = o_u2;
    o_block[7]  = o_u3;
    o_block[8]  = o_color[0];
    o_block[9]  = o_color[1];
    o_block[10] = o_color[2];
    o_block[11] = o_color[3];
    o_block[12] = o_color[4];
    o_block[13] = o_color[5];
    o_block[14] = o_color[6];
    o_block[15] = o_color[7];
    o_block[16] = o_size[0];
    o_block[17] = o_size[1];
    o_block[18] = o_size[2];
    o_block[19] = o_size[3];
    o_block[20] = o_size[4];
    o_block[21] = o_size[5];
    o_block[22] = o_size[6];
    o_block[23] = o_size[7];
    o_block[24] = o_size[8];
    o_block[25] = o_size[9];
    o_block[26] = o_plain;

    /*{
        int i, j;
        fprintf(stderr, "o_color\n");
        for (i = 0; i < 8; i ++) {
            for (j = 0; j < o_length; j ++) {
                fprintf(stderr, " %2d", o_color[i][j]);
            }
            fprintf(stderr, "\n");
        }
        fprintf(stderr, "--------\n");
    }*/

    /*fprintf(stderr, "placetags\n");*/
    makecuts(0, o_length);
    placetags(0, o_length);
    /*fprintf(stderr, "makeoutput\n");*/
    return makeoutput();
}
